/*
 * AppController.h
 * Classes
 * 
 * Created by Gregory Barchard on 23/09/2010.
 * 
 * Copyright (c) 2010 BuySellAds.com
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 * Neither the name of the project's author nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

//
//  BSAZone.h
//  BSAAdFramework
//
//  Created by Rick Fillion on 6/30/10.
//  Copyright 2010 BuySellAds. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BSAZoneFormat.h"


@interface BSAZone : NSObject {
    NSNumber *identifier;
    NSNumber *siteIdentifier;
    NSNumber *width;
    NSNumber *height;
    NSArray *ads;
    NSNumber *numberOfAds;
    BSAZoneFormat format;
    BOOL showsPlaceholderAd;
    BOOL repeatsPlaceholderAds;
    NSDictionary *backfill;
}

@property (readwrite, retain) NSNumber *identifier;
@property (readwrite, retain) NSNumber *siteIdentifier;
@property (readwrite, retain) NSNumber *width;
@property (readwrite, retain) NSNumber *height;
@property (readwrite, retain) NSArray *ads;
@property (readwrite, retain) NSNumber *numberOfAds;
@property (readwrite, assign) BSAZoneFormat format;
@property (readwrite, assign) BOOL showsPlaceholderAd;
@property (readwrite, assign) BOOL repeatsPlaceholderAds;
@property (readwrite, retain) NSDictionary *backfill;

- (id)initWithDictionary:(NSDictionary *)dictionary;
- (NSArray *)shuffledAds;
- (NSString *)description;
@end
